/*
 */

#ifndef __XFSM_CLIENT_H__
#define __XFSM_CLIENT_H__

#include <X11/SM/SMlib.h>

#include <glib.h>

typedef struct _XfsmClient	XfsmClient;
typedef struct _XfsmClientList	XfsmClientList;
typedef struct _XfsmManager	XfsmManager;

struct _XfsmClient
{
	IceConn		iceConnection;
	SmsConn		smsConnection;

	gchar		*clientHostname;

	gchar		*clientID;

	SmProp		**properties;
	int		numProps;

	/* */
	XfsmManager	*manager;
};

struct _XfsmManager
{
	GList	*running;
	GList	*pending;
	gchar	*filename;
};

/* XfsmClient prototypes */
extern XfsmClient	*client_new(SmsConn, XfsmManager *);
extern void		client_free(XfsmClient *);
extern void		client_set_properties(XfsmClient *, int, SmProp **);

/* XfsmManager prototypes */
extern void		manager_append(XfsmManager *, XfsmClient *);
extern void		manager_remove(XfsmManager *, XfsmClient *);
extern void		manager_save(XfsmManager *);
extern XfsmManager	*manager_load(const gchar *);
extern gboolean		manager_start_pending(XfsmManager *);

#define clist_append(lst, clnt)						\
do {									\
	(lst) = g_list_append((lst), (gpointer)(clnt));			\
} while (FALSE)

#define clist_remove(lst, clnt)						\
do {									\
	(lst) = g_list_remove((lst), (gconstpointer)(clnt));		\
} while (FALSE)

#endif	/* !__XFSM_CLIENT_H__ */
