/*
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef HAVE_SYS_PARAM_H
#include <sys/param.h>
#endif

#include <stdio.h>

#include <X11/SM/SMlib.h>

#include <libxml/tree.h>

#include "client.h"

#if 0
#define BUFSIZ		(1024)

static void
convARRAY8toString(char *buffer, int buflen, const SmPropValue *value);
{
	int length;

	length = MIN(buflen - 1, value->length);
	memcpy(buffer, value->value, length);
	buffer[length] = '\0';
}

static void
convCARD8toString(char *buffer, int buflen, const SmPropValue *value)
{
	snprintf(buffer, buflen, "%d", (int)value->value);
}

struct converter {
	void (*func)(char *, int, const SmPropValue *);
	const char *name;
};

struct converter converters[] = {
	{ convARRAY8toString, "ARRAY8" },
	{ convARRAY8toString, "LISTofARRAY8" }
};

/* */
static void
write_property(xmlNodePtr node, const SmProp *property)
{
	char buffer[BUFSIZ];
	xmlNodePtr pnode;
	xmlNodePtr vnode;
	int n;

	pnode = xmlNewTextChild(node, NULL, "property", NULL);

	xmlSetProp(pnode, "name", property->name);
	xmlSetProp(pnode, "type", property->type);

	for (n = 0; n < property->num_vals; n++) {
#if 0
		const SmPropValue *value = property->vals + n;
		int length = MIN(BUFSIZ - 1, value->length);

		memcpy(buffer, value->value, length);
		buffer[length] = '\0';

		vnode = xmlNewTextChild(pnode, NULL, "value", buffer);
#endif
		const SmPropValue *vp;

		vp = property->vals + n;
	}
}
#endif

/* */
void
write_client(const XfsmClient *client, const char *filename)
{
#if 0
	SmPropValue *vp, *ve;
	SmProp **pp, **pe;
	xmlDocPtr doc;
	xmlNodePtr node, pnode;

	doc = xmlNewDoc("1.0");
	doc->children = xmlNewDocRawNode(doc, NULL, "client", NULL);

	node = (xmlNodePtr)doc->children;
	xmlDocSetRootElement(doc, node);

	xmlSetProp(node, "hostname", client->clientHostname);
	xmlSetProp(node, "id", client->clientID);

	pe = client->properties + client->numProps;

	for (pp = client->properties; pp < pe; pp++) {
		pnode = xmlNewTextChild(node, NULL, "property", NULL);

		xmlSetProp(pnode, "name", (*pp)->name);
		xmlSetProp(pnode, "type", (*pp)->type);

		ve = (*pp)->vals + (*pp)->num_vals;

		for (vp = (*pp)->vals; vp < ve; vp++) {
			xmlNewTextChild(pnode, NULL, "value", vp->value);
		}
	}

	xmlSaveFormatFile(filename, doc, 1);
	xmlFreeDoc(doc);
#endif

	xmlNodePtr node;
	xmlDocPtr doc;

	doc = xmlNewDoc("1.0");
	doc->children = xmlNewDocRawNode(doc, NULL, "clients", NULL);

	node = (xmlNodePtr)doc->children;
	xmlDocSetRootElement(doc, node);

	client_save(client, node);

	xmlSaveFormatFile(filename, doc, 1);
	xmlFreeDoc(doc);
}

#if 0
/* */
static void
write_string(FILE *fp, const char *string)
{
	int length;

	length = strlen(string);
	fwrite(&length, sizeof(length), 1, fp);
	fwrite(string, sizeof(*string), length + 1, fp);
}

/* */
static void
client_save(FILE *fp, const XfsmClient *client)
{
	SmProp **pp, **pe;
	int n;

	write_string(fp, client->clientID);
	write_string(fp, client->clientHostname);

	fwrite(&client->numProps, sizeof(client->numProps), 1, fp);

	pe = client->properties + client->numProps;

	for (pp = client->properties; pp < pe; pp++) {
		write_string(fp, (*pp)->name);
		write_string(fp, (*pp)->type);

		fwrite(&((*pp)->num_vals), sizeof((*pp)->num_vals), 1, fp);

		for (n = 0; n < (*pp)->num_vals; n++) {
			SmPropValue *value;

			value = (*pp)->vals + n;
			fwrite(&value->length, sizeof(value->length), 1, fp);
			fwrite(value->value, 1, value->length, fp);
		}
	}
}

void
write_client(const XfsmClient *client, const char *filename)
{
	FILE *fp;

	if ((fp = fopen(filename, "wb")) == NULL) {
		perror("fopen");
		return;
	}

	client_save(fp, client);

	(void)fclose(fp);
}
#endif
