/*
 */

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <X11/ICE/ICEutil.h>
#include <X11/SM/SMlib.h>

#include <gtk/gtk.h>

#include "client.h"
#include "ice-layer.h"
#include "sm-layer.h"

static gboolean
delayed_exec(const gchar *prog)
{
	g_print("EXEC %s\n", prog);
	g_spawn_command_line_async(prog, NULL);
	return(FALSE);
}

int
main(int argc, char **argv)
{
	XfsmManager *manager;
	char error[1024];

	gtk_init(&argc, &argv);

	manager = manager_load("/tmp/XFSM-save");

	if (!xfsm_sm_init(error, 1024, manager)) {
		fprintf(stderr, "xfsm_sm_init() failed: %s\n", error);
		return(EXIT_FAILURE);
	}

	if (!manager_start_pending(manager))
		g_idle_add((GSourceFunc)delayed_exec, "xterm");

	gtk_main();

	return(EXIT_SUCCESS);
}

